diff --git a/game/client/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java b/game/client/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
index 636f9046e..b63e5c2bf 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ControllerGlyphElement.java
@@ -1,119 +1,76 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.input.controller.Button;
 import net.minecraft.client.input.controller.ControllerInput;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
 
 public class ControllerGlyphElement extends Gui {
-    private final Minecraft minecraft;
-
-    public ControllerGlyphElement(Minecraft minecraft) {
-        this.minecraft = minecraft;
-    }
-
-    public void drawButton(ControllerInput controller, Button button, int x, int y, boolean pressed) {
-        int u = getButtonU(controller, button);
-        int v = getButtonV(controller, button);
-        int sizeU = getButtonSizeU(controller, button);
-        int sizeV = getButtonSizeV(controller, button);
-        int vOffset = 0;
-        if (pressed) {
-            vOffset = sizeV;
-        }
+    public static final int GLYPH_WIDTH = 15;
+    public static final int GLYPH_HEIGHT = 15;
 
+    private static final int GLYPH_U = 0;
+    private static final int GLYPH_V = 118;
 
-        minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
+    public enum Glyph {
+        BUTTON_A(GLYPH_U + GLYPH_WIDTH * 0, GLYPH_V + GLYPH_HEIGHT * 0),
+        BUTTON_B(GLYPH_U + GLYPH_WIDTH * 1, GLYPH_V + GLYPH_HEIGHT * 0),
+        BUTTON_X(GLYPH_U + GLYPH_WIDTH * 2, GLYPH_V + GLYPH_HEIGHT * 0),
+        BUTTON_Y(GLYPH_U + GLYPH_WIDTH * 3, GLYPH_V + GLYPH_HEIGHT * 0),
+        D_PAD_UP(GLYPH_U + GLYPH_WIDTH * 4, GLYPH_V + GLYPH_HEIGHT * 0),
+        D_PAD_RIGHT(GLYPH_U + GLYPH_WIDTH * 5, GLYPH_V + GLYPH_HEIGHT * 0),
+        D_PAD_DOWN(GLYPH_U + GLYPH_WIDTH * 6, GLYPH_V + GLYPH_HEIGHT * 0),
+        D_PAD_LEFT(GLYPH_U + GLYPH_WIDTH * 7, GLYPH_V + GLYPH_HEIGHT * 0),
+        SHOULDER_LEFT(GLYPH_U + GLYPH_WIDTH * 0, GLYPH_V + GLYPH_HEIGHT * 1),
+        SHOULDER_RIGHT(GLYPH_U + GLYPH_WIDTH * 1, GLYPH_V + GLYPH_HEIGHT * 1),
+        TRIGGER_LEFT(GLYPH_U + GLYPH_WIDTH * 2, GLYPH_V + GLYPH_HEIGHT * 1),
+        TRIGGER_RIGHT(GLYPH_U + GLYPH_WIDTH * 3, GLYPH_V + GLYPH_HEIGHT * 1),
+        STICK_LEFT_PRESS(GLYPH_U + GLYPH_WIDTH * 4, GLYPH_V + GLYPH_HEIGHT * 1),
+        STICK_RIGHT_PRESS(GLYPH_U + GLYPH_WIDTH * 5, GLYPH_V + GLYPH_HEIGHT * 1),
+        BUTTON_START(GLYPH_U + GLYPH_WIDTH * 6, GLYPH_V + GLYPH_HEIGHT * 1),
+        BUTTON_BACK(GLYPH_U + GLYPH_WIDTH * 7, GLYPH_V + GLYPH_HEIGHT * 1),
+        STICK_LEFT_UP(GLYPH_U + GLYPH_WIDTH * 0, GLYPH_V + GLYPH_HEIGHT * 2),
+        STICK_LEFT_RIGHT(GLYPH_U + GLYPH_WIDTH * 1, GLYPH_V + GLYPH_HEIGHT * 2),
+        STICK_LEFT_DOWN(GLYPH_U + GLYPH_WIDTH * 2, GLYPH_V + GLYPH_HEIGHT * 2),
+        STICK_LEFT_LEFT(GLYPH_U + GLYPH_WIDTH * 3, GLYPH_V + GLYPH_HEIGHT * 2),
+        STICK_RIGHT_UP(GLYPH_U + GLYPH_WIDTH * 4, GLYPH_V + GLYPH_HEIGHT * 2),
+        STICK_RIGHT_RIGHT(GLYPH_U + GLYPH_WIDTH * 5, GLYPH_V + GLYPH_HEIGHT * 2),
+        STICK_RIGHT_DOWN(GLYPH_U + GLYPH_WIDTH * 6, GLYPH_V + GLYPH_HEIGHT * 2),
+        STICK_RIGHT_LEFT(GLYPH_U + GLYPH_WIDTH * 7, GLYPH_V + GLYPH_HEIGHT * 2);
 
-        drawTexturedModalRect(x, y, u, v + vOffset, sizeU, sizeV);
-    }
+        private final int u;
+        private final int v;
 
-    public void drawDPad(ControllerInput controllerInput, int x, int y, boolean up, boolean right, boolean down, boolean left) {
-        int u = 0;
-        int v = 72;
-        int sizeU = 46;
-        int sizeV = 46;
-
-        minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controllerInput.getType().getAssetName() + ".png").bind();
-
-        drawTexturedModalRect(x, y, u, v, sizeU, sizeV);
-
-        if (up) {
-            drawTexturedModalRect(x, y, 46, 72, 46, 15);
-        }
-        if (right) {
-            drawTexturedModalRect(x + 31, y, 77, 72, 15, 46);
-        }
-        if (down) {
-            drawTexturedModalRect(x, y + 31, 46, 103, 46, 15);
+        Glyph(final int u, final int v) {
+            this.u = u;
+            this.v = v;
         }
-        if (left) {
-            drawTexturedModalRect(x, y, 46, 72, 15, 46);
-        }
-    }
 
-    private int getButtonU(ControllerInput controller, Button button) {
-        if (button == controller.buttonA || button == controller.digitalPad.up) {
-            return 0;
-        } else if (button == controller.buttonB || button == controller.digitalPad.right) {
-            return 18;
-        } else if (button == controller.buttonX || button == controller.digitalPad.down) {
-            return 36;
-        } else if (button == controller.buttonY || button == controller.digitalPad.left) {
-            return 54;
-        } else if (button == controller.buttonLeftShoulder) {
-            return 97;
-        } else if (button == controller.buttonRightShoulder) {
-            return 72;
-        } else if (button == controller.buttonLeftTrigger) {
-            return 139;
-        } else if (button == controller.buttonRightTrigger) {
-            return 122;
-        } else if (button == controller.buttonStart) {
-            return 72;
-        } else if (button == controller.buttonBack) {
-            return 87;
-        } else {
-            return 0;
+        public int getU() {
+            return this.u;
         }
-    }
 
-    private int getButtonV(ControllerInput controller, Button button) {
-        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder || button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
-            return 0;
-        } else if (button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
-            return 36;
-        } else if (button == controller.buttonStart || button == controller.buttonBack) {
-            return 26;
-        } else {
-            return 0;
+        public int getV() {
+            return this.v;
         }
     }
 
-    public int getButtonSizeU(ControllerInput controller, Button button) {
-        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
-            return 18;
-        } else if (button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder) {
-            return 25;
-        } else if (button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
-            return 17;
-        } else if (button == controller.buttonStart || button == controller.buttonBack) {
-            return 15;
-        } else {
-            return 0;
-        }
+    private final @NotNull Minecraft minecraft;
+
+    public ControllerGlyphElement(final @NotNull Minecraft minecraft) {
+        this.minecraft = minecraft;
     }
 
-    public int getButtonSizeV(ControllerInput controller, Button button) {
-        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
-            return 18;
-        } else if (button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder) {
-            return 13;
-        } else if (button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
-            return 15;
-        } else if (button == controller.buttonStart || button == controller.buttonBack) {
-            return 15;
+    public void drawGlyph(final @Nullable ControllerInput controller, final @NotNull Glyph glyph, final int x, final int y) {
+        if (controller == null) {
+            this.minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/xbox_one.png").bind();
         } else {
-            return 0;
+            this.minecraft.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
         }
+
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
+
+        drawTexturedModalRect(x, y, glyph.getU(), glyph.getV(), GLYPH_WIDTH, GLYPH_HEIGHT);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Screen.java b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
index 04e5939b2..c5045b9f9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
@@ -47,10 +47,10 @@ public abstract class Screen extends Gui {
         return button;
     }
 
-    public void render(int xm, int ym, float partialTick) {
+    public void render(int mx, int my, float partialTick) {
         for (int i = 0; i < buttons.size(); i++) {
             ButtonElement button = buttons.get(i);
-            button.drawButton(mc, xm, ym);
+            button.drawButton(mc, mx, my);
         }
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
index 359bd1fdc..6be2b2ce9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
@@ -131,7 +131,7 @@ public class ScreenAddServer extends Screen
     }
 
     @Override
-	public void render(int xm, int ym, float partialTick)
+	public void render(int mx, int my, float partialTick)
     {
         I18n stringtranslate = I18n.getInstance();
         renderBackground();
@@ -140,6 +140,6 @@ public class ScreenAddServer extends Screen
         drawString(font, stringtranslate.translateKey("gui.add_server.label.ip_address"), ipTextField.xPosition, ipTextField.yPosition - 14, 0xa0a0a0);
         ipTextField.drawTextBox();
         serverNameTextField.drawTextBox();
-        super.render(xm, ym, partialTick);
+        super.render(mx, my, partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenBadJavaArch.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenBadJavaArch.java
index bc7442303..3449f27d0 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenBadJavaArch.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenBadJavaArch.java
@@ -54,7 +54,7 @@ public class ScreenBadJavaArch extends Screen
     }
 
     @Override
-	public void render(int xm, int ym, float partialTick)
+	public void render(int mx, int my, float partialTick)
     {
         I18n i = I18n.getInstance();
         renderBackground();
@@ -63,7 +63,7 @@ public class ScreenBadJavaArch extends Screen
         drawString(font, i.translateKey("gui.bad_java_arch.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xa0a0a0);
         drawString(font, i.translateKey("gui.bad_java_arch.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xa0a0a0);
         drawString(font, i.translateKey("gui.bad_java_arch.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xa0a0a0);
-        super.render(xm, ym, partialTick);
+        super.render(mx, my, partialTick);
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConflictWarning.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConflictWarning.java
index ca305d79e..ddf85e1a4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConflictWarning.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConflictWarning.java
@@ -30,7 +30,7 @@ public class ScreenConflictWarning extends Screen
     }
 
     @Override
-	public void render(int xm, int ym, float partialTick)
+	public void render(int mx, int my, float partialTick)
     {
         I18n i = I18n.getInstance();
         renderBackground();
@@ -39,6 +39,6 @@ public class ScreenConflictWarning extends Screen
         drawString(font, i.translateKey("gui.conflict_warning.label.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xa0a0a0);
         drawString(font, i.translateKey("gui.conflict_warning.label.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xa0a0a0);
         drawString(font, i.translateKey("gui.conflict_warning.label.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xa0a0a0);
-        super.render(xm, ym, partialTick);
+        super.render(mx, my, partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
index eccee5293..e5a2070b3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
@@ -53,12 +53,12 @@ public class ScreenConnectFailed extends Screen
     }
 
     @Override
-	public void render(int xm, int ym, float partialTick)
+	public void render(int mx, int my, float partialTick)
     {
         renderBackground();
         drawStringCentered(font, errorMessage, width / 2, height / 2 - 50, 0xffffff);
         drawStringCentered(font, errorDetail, width / 2, height / 2 - 10, 0xffffff);
-        super.render(xm, ym, partialTick);
+        super.render(mx, my, partialTick);
     }
 
     private String errorMessage;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
index 935d1ddd2..57bfb92f1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
@@ -80,14 +80,14 @@ public class ScreenConnectToIp extends Screen
     }
 
     @Override
-	public void render(int xm, int ym, float partialTick)
+	public void render(int mx, int my, float partialTick)
     {
         I18n i18n = I18n.getInstance();
         renderBackground();
         drawStringCentered(font, i18n.translateKey("gui.connect_to_ip.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
         drawString(font, i18n.translateKey("gui.connect_to_ip.label.enter_ip"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xa0a0a0);
         textField.drawTextBox();
-        super.render(xm, ym, partialTick);
+        super.render(mx, my, partialTick);
     }
 
     private TextFieldElement textField;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
index db864d7c9..f2b6cf798 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
@@ -101,7 +101,7 @@ public class ScreenConnecting extends Screen
     }
 
     @Override
-	public void render(int xm, int ym, float partialTick)
+	public void render(int mx, int my, float partialTick)
     {
         renderBackground();
         I18n stringtranslate = I18n.getInstance();
@@ -114,7 +114,7 @@ public class ScreenConnecting extends Screen
             drawStringCentered(font, stringtranslate.translateKey("gui.connecting.label.logging_in"), width / 2, height / 2 - 50, 0xffffff);
             drawStringCentered(font, clientHandler.message, width / 2, height / 2 - 10, 0xffffff);
         }
-        super.render(xm, ym, partialTick);
+        super.render(mx, my, partialTick);
     }
 
     private PacketHandlerClient clientHandler;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
index 649630868..0f9288eff 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui;
 
 import net.minecraft.client.input.InputHandler;
 import net.minecraft.client.input.InputType;
+import net.minecraft.client.input.controller.Button;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.input.controller.ControllerType;
 import net.minecraft.client.input.controller.Joystick;
@@ -15,7 +16,6 @@ import static org.lwjgl.opengl.GL11.*;
 public class ScreenControllerSetup extends Screen {
     private ControllerInput lastController = null;
     private ButtonElement controllerButton;
-    private ControllerGlyphElement glyphRenderer;
 
     public ScreenControllerSetup(Screen parentScreen) {
         super(parentScreen);
@@ -33,8 +33,6 @@ public class ScreenControllerSetup extends Screen {
 
         buttons.add(new ButtonElement(-1, width / 2 - 100, height - 40, I18n.getInstance().translateKey("gui.controller_setup.button.back")).setListener((e) -> mc.displayScreen(parentScreen)));
 
-        this.glyphRenderer = new ControllerGlyphElement(mc);
-
         updateDisplay();
     }
 
@@ -48,88 +46,86 @@ public class ScreenControllerSetup extends Screen {
     }
 
     @Override
-    public void render(int xm, int ym, float partialTick) {
+    public void render(int mx, int my, float partialTick) {
         renderBackground();
-        super.render(xm, ym, partialTick);
+        super.render(mx, my, partialTick);
 
         ControllerInput controller = mc.controllerInput;
 
         if (controller != null) {
             boolean swapJoystickAndDPad = controller.getType().getLayout() == ControllerType.Layout.XBOX || controller.getType().getLayout() == ControllerType.Layout.NINTENDO;
-            int y = height / 2 - 64;
 
-            int x1 = width / 2;
+            final int x = width / 2 - 232 / 2;
+            final int y = height / 2 - 164 / 2;
+
+            final int[][] slots = {
+                { 23, 36 },
+                { 64, 67 },
+                { 122, 67 },
+                { 163, 36 }
+            };
+            final int[][] shoulderSlots = {
+                { 28, 15 },
+                { 179, 15 }
+            };
+            final int[][] triggerSlots = {
+                { 36, 0 },
+                { 179, 0 }
+            };
+            final int[][] metaSlots = {
+                { 92, 40 },
+                { 125, 40 }
+            };
+
+            final int dPadSlot = swapJoystickAndDPad ? 1 : 0;
+            final int joyLeftSlot = swapJoystickAndDPad ? 0 : 1;
+            final int joyRightSlot = 2;
+            final int faceButtonsSlot = 3;
 
             glDisable(GL_DEPTH_TEST);
-            glDisable(GL_CULL_FACE);
-            glDisable(GL_TEXTURE_2D);
-            if (swapJoystickAndDPad) {
-                drawJoystick(controller.joyLeft, x1 - 100 + 8, y + 32 + 4 + 8);
-            } else {
-                drawJoystick(controller.joyLeft, x1 - 48, y + 96);
-            }
-            drawJoystick(controller.joyRight, x1 - 48 + 64, y + 96);
 
-            GL11.glEnable(GL_TEXTURE_2D);
             font.drawCenteredString("(" + controller.getType().getPrintableName() + ")", width / 2, 40, 0xFFFFFF);
 
-            int w = glyphRenderer.getButtonSizeU(controller, controller.buttonLeftTrigger);
-            glyphRenderer.drawButton(controller, controller.buttonLeftTrigger, x1 - 65 - w, y, controller.buttonLeftTrigger.isPressed());
-            glyphRenderer.drawButton(controller, controller.buttonRightTrigger, x1 + 65, y, controller.buttonRightTrigger.isPressed());
-            w = glyphRenderer.getButtonSizeU(controller, controller.buttonBack);
-            glyphRenderer.drawButton(controller, controller.buttonBack, x1 - 20 - w, y + 32, controller.buttonBack.isPressed());
-            glyphRenderer.drawButton(controller, controller.buttonStart, x1 + 20, y + 32, controller.buttonStart.isPressed());
-            w = glyphRenderer.getButtonSizeU(controller, controller.buttonLeftShoulder);
-            glyphRenderer.drawButton(controller, controller.buttonLeftShoulder, x1 - 65 - w, y + 15, controller.buttonLeftShoulder.isPressed());
-            glyphRenderer.drawButton(controller, controller.buttonRightShoulder, x1 + 65, y + 15, controller.buttonRightShoulder.isPressed());
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/layout.png").bind();
+
+            drawTexturedModalRect(x, y, 0, 0, 232, 164);
+
+            // Draw joysticks
+            drawJoystick(controller, x + slots[joyLeftSlot][0], y + slots[joyLeftSlot][1], controller.joyLeft.getX(), controller.joyLeft.getY(), controller.joyLeft.getButton().isPressed());
+            drawJoystick(controller, x + slots[joyRightSlot][0], y + slots[joyRightSlot][1], controller.joyRight.getX(), controller.joyRight.getY(), controller.joyRight.getButton().isPressed());
+
+            // Draw Back and Start buttons
+            drawButton(controller, controller.buttonBack, x + metaSlots[0][0], y + metaSlots[0][1], controller.buttonBack.isPressed());
+            drawButton(controller, controller.buttonStart, x + metaSlots[1][0], y + metaSlots[1][1], controller.buttonStart.isPressed());
+
+            // Draw triggers
+            drawButton(controller, controller.buttonLeftTrigger, x + triggerSlots[0][0], y + triggerSlots[0][1], controller.buttonLeftTrigger.isPressed());
+            drawButton(controller, controller.buttonRightTrigger, x + triggerSlots[1][0], y + triggerSlots[1][1], controller.buttonRightTrigger.isPressed());
+
+            // Draw shoulder buttons
+            drawButton(controller, controller.buttonLeftShoulder, x + shoulderSlots[0][0], y + shoulderSlots[0][1], controller.buttonLeftShoulder.isPressed());
+            drawButton(controller, controller.buttonRightShoulder, x + shoulderSlots[1][0], y + shoulderSlots[1][1], controller.buttonRightShoulder.isPressed());
 
             //Buttons
-            drawButtons(controller, width / 2 + 50, y + 32);
+            drawButtons(controller, x + slots[faceButtonsSlot][0], y + slots[faceButtonsSlot][1]);
 
             //Digital Pad
-            if (swapJoystickAndDPad) {
-                glyphRenderer.drawDPad(controller, x1 - 48 - 8, y + 96 - 8, controller.digitalPad.up.isPressed(), controller.digitalPad.right.isPressed(), controller.digitalPad.down.isPressed(), controller.digitalPad.left.isPressed());
-            } else {
-                glyphRenderer.drawDPad(controller, x1 - 100, y + 32 + 4, controller.digitalPad.up.isPressed(), controller.digitalPad.right.isPressed(), controller.digitalPad.down.isPressed(), controller.digitalPad.left.isPressed());
-            }
+            drawDPad(controller, x + slots[dPadSlot][0], y + slots[dPadSlot][1], controller.digitalPad.up.isPressed(), controller.digitalPad.right.isPressed(), controller.digitalPad.down.isPressed(), controller.digitalPad.left.isPressed());
 
         }
     }
 
     private void drawButtons(ControllerInput controller, int x, int y) {
-        int w = 20;
+        int w = 14;
 
-        glyphRenderer.drawButton(controller, controller.buttonA, x + w * 1, y + w * 2, controller.buttonA.isPressed());
-        glyphRenderer.drawButton(controller, controller.buttonB, x + w * 2, y + w * 1, controller.buttonB.isPressed());
-        glyphRenderer.drawButton(controller, controller.buttonX, x + w * 0, y + w * 1, controller.buttonX.isPressed());
-        glyphRenderer.drawButton(controller, controller.buttonY, x + w * 1, y + w * 0, controller.buttonY.isPressed());
+        drawButton(controller, controller.buttonA, x + w * 1, y + w * 2, controller.buttonA.isPressed());
+        drawButton(controller, controller.buttonB, x + w * 2, y + w * 1, controller.buttonB.isPressed());
+        drawButton(controller, controller.buttonX, x + w * 0, y + w * 1, controller.buttonX.isPressed());
+        drawButton(controller, controller.buttonY, x + w * 1, y + w * 0, controller.buttonY.isPressed());
     }
 
     @Override
-    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
-
-    }
-
-    private void drawJoystick(Joystick joystick, int x, int y) {
-        glDisable(GL_TEXTURE_2D);
-
-        glBegin(GL_QUADS);
-        glColor3d(0.5, 0.5, 0.5);
-        rectangle(x, y, 32, 32);
-        glColor3d(0.0, 1.0, 0.0);
-        if (joystick.getButton().isPressed()) glColor3d(1.0, 0.0, 0.0);
-        rectangle(x + (joystick.getX() * 0.5 + 0.5) * 32 - 1, y + (joystick.getY() * 0.5 + 0.5) * 32 - 1, 2, 2);
-        glEnd();
-
-        glEnable(GL_TEXTURE_2D);
-    }
-
-    private void rectangle(double x, double y, double w, double h) {
-        glVertex2d(x, y);
-        glVertex2d(x + w, y);
-        glVertex2d(x + w, y + h);
-        glVertex2d(x, y + h);
-    }
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my) { }
 
     @Override
     protected void buttonClicked(ButtonElement button) {
@@ -188,4 +184,124 @@ public class ScreenControllerSetup extends Screen {
         mc.gameSettings.saveOptions();
     }
 
+    private void drawButton(ControllerInput controller, Button button, int x, int y, boolean pressed) {
+        int u = getButtonU(controller, button);
+        int v = getButtonV(controller, button);
+        int sizeU = getButtonSizeU(controller, button);
+        int sizeV = getButtonSizeV(controller, button);
+        int vOffset = 0;
+        if (pressed) {
+            vOffset = sizeV;
+        }
+
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controller.getType().getAssetName() + ".png").bind();
+
+        drawTexturedModalRect(x, y, u, v + vOffset, sizeU, sizeV);
+    }
+
+    private void drawDPad(ControllerInput controllerInput, int x, int y, boolean up, boolean right, boolean down, boolean left) {
+        int u = 0;
+        int v = 72;
+        int sizeU = 46;
+        int sizeV = 46;
+
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controllerInput.getType().getAssetName() + ".png").bind();
+
+        drawTexturedModalRect(x, y, u, v, sizeU, sizeV);
+
+        if (up) {
+            drawTexturedModalRect(x, y, 46, 72, 46, 15);
+        }
+        if (right) {
+            drawTexturedModalRect(x + 31, y, 77, 72, 15, 46);
+        }
+        if (down) {
+            drawTexturedModalRect(x, y + 31, 46, 103, 46, 15);
+        }
+        if (left) {
+            drawTexturedModalRect(x, y, 46, 72, 15, 46);
+        }
+    }
+
+    private void drawJoystick(ControllerInput controllerInput, int x, int y, float axisX, float axisY, boolean clicked) {
+        int u = 92;
+        int v = 72;
+        int sizeU = 46;
+        int sizeV = 46;
+
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/" + controllerInput.getType().getAssetName() + ".png").bind();
+
+        drawTexturedModalRect(x, y, u, v, sizeU, sizeV);
+
+        int thumbU = clicked ? 184 : 138;
+        int thumbV = 72;
+
+        drawTexturedModalRect((int) (x + (axisX * sizeU / 3)), (int) (y + (axisY * sizeV / 3)), thumbU, thumbV, sizeU, sizeV);
+    }
+
+    private int getButtonU(ControllerInput controller, Button button) {
+        if (button == controller.buttonA || button == controller.digitalPad.up) {
+            return 0;
+        } else if (button == controller.buttonB || button == controller.digitalPad.right) {
+            return 18;
+        } else if (button == controller.buttonX || button == controller.digitalPad.down) {
+            return 36;
+        } else if (button == controller.buttonY || button == controller.digitalPad.left) {
+            return 54;
+        } else if (button == controller.buttonLeftShoulder) {
+            return 97;
+        } else if (button == controller.buttonRightShoulder) {
+            return 72;
+        } else if (button == controller.buttonLeftTrigger) {
+            return 139;
+        } else if (button == controller.buttonRightTrigger) {
+            return 122;
+        } else if (button == controller.buttonStart) {
+            return 72;
+        } else if (button == controller.buttonBack) {
+            return 87;
+        } else {
+            return 0;
+        }
+    }
+
+    private int getButtonV(ControllerInput controller, Button button) {
+        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder || button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
+            return 0;
+        } else if (button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
+            return 36;
+        } else if (button == controller.buttonStart || button == controller.buttonBack) {
+            return 26;
+        } else {
+            return 0;
+        }
+    }
+
+    private int getButtonSizeU(ControllerInput controller, Button button) {
+        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
+            return 18;
+        } else if (button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder) {
+            return 25;
+        } else if (button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
+            return 17;
+        } else if (button == controller.buttonStart || button == controller.buttonBack) {
+            return 15;
+        } else {
+            return 0;
+        }
+    }
+
+    private int getButtonSizeV(ControllerInput controller, Button button) {
+        if (button == controller.buttonA || button == controller.buttonB || button == controller.buttonX || button == controller.buttonY || button == controller.digitalPad.up || button == controller.digitalPad.right || button == controller.digitalPad.down || button == controller.digitalPad.left) {
+            return 18;
+        } else if (button == controller.buttonLeftShoulder || button == controller.buttonRightShoulder) {
+            return 13;
+        } else if (button == controller.buttonLeftTrigger || button == controller.buttonRightTrigger) {
+            return 15;
+        } else if (button == controller.buttonStart || button == controller.buttonBack) {
+            return 15;
+        } else {
+            return 0;
+        }
+    }
 }
